/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// EncoderSetupDlg.cpp : implementation file
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "probedemo.h"
#include "EncoderSetupDlg.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CEncoderSetupDlg dialog

CEncoderSetupDlg::CEncoderSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEncoderSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEncoderSetupDlg)
	m_strVideoName = _T("");
	m_strCodecName = _T("");
	//}}AFX_DATA_INIT
	m_LiveCamera	= NULL;
	m_FirstLoad		= FALSE;
}

CEncoderSetupDlg::~CEncoderSetupDlg()
{
	DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEncoderSetupDlg)
	DDX_Control(pDX, IDC_EDIT_VIDEO_NAME, m_edtVideoName);
	DDX_Control(pDX, IDC_EDIT_CODEC_NAME, m_edtCodecName);
	DDX_Control(pDX, IDC_COMBO_RESOLUTION, m_cboResolution);
	DDX_Control(pDX, IDC_COMBO_CODEC_TYPE, m_cboCodecType);
	DDX_Control(pDX, IDC_COMBO_QUALITY, m_cboQuality);
	DDX_Control(pDX, IDC_COMBO_GOP_INTERVAL, m_cboGOPInterval);
	DDX_Control(pDX, IDC_COMBO_FRAME_RATE, m_cboFrameRate);
	DDX_Control(pDX, IDC_COMBO_BIT_RATE_MODE, m_cboBitRateMode);
	DDX_Control(pDX, IDC_COMBO_BIT_RATE, m_cboBitRate);
	DDX_Control(pDX, IDC_TAB_ENCODER_SETUP, m_EncoderSetupTab);
	DDX_Text(pDX, IDC_EDIT_VIDEO_NAME, m_strVideoName);
	DDX_Text(pDX, IDC_EDIT_CODEC_NAME, m_strCodecName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEncoderSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CEncoderSetupDlg)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB_ENCODER_SETUP, OnSelchangeTabEncoderSetup)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnButtonApply)
	ON_CBN_SELCHANGE(IDC_COMBO_RESOLUTION, OnSelchangeComboResolution)
	ON_CBN_SELCHANGE(IDC_COMBO_BIT_RATE_MODE, OnSelchangeComboBitRateMode)
	ON_CBN_SELCHANGE(IDC_COMBO_CODEC_TYPE, OnSelchangeComboCodecType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CEncoderSetupDlg message handlers

void CEncoderSetupDlg::Init( void *pLiveCamera )
{
	ShowWindow( SW_SHOW );

	m_LiveCamera = (CLiveObject *)pLiveCamera; 

	m_EncoderSetupTab.InsertItem( CHANNEL1, "Channel 1" );
	m_EncoderSetupTab.InsertItem( CHANNEL2, "Channel 2" );
	m_EncoderSetupTab.InsertItem( CHANNEL3, "Channel 3" );
	m_EncoderSetupTab.InsertItem( CHANNEL4, "Channel 4" );
	m_EncoderSetupTab.InsertItem( CHANNEL5, "Channel 5" );

	m_EncoderSetupTab.SetCurSel( CHANNEL1 );

	//...........................................................

	GetEncoderDataFromServer();
	SetChannelEncoderData();
	
	//...........................................................

	m_FirstLoad = TRUE;

	UpdateData( FALSE );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 720p  ȯ
void CEncoderSetupDlg::CalcFrameRate( int nCurChannel )
{
	int i;
	double totalUsedFrames = 0;
	for( i=0; i<5; i++ )
	{
		TRACE( "Index[%d], FrameRate(%d)\n", i, m_EncoderSetupInfo[i].m_framerate );

		if ( (m_EncoderSetupInfo[i].m_codec_type != CODEC_NONE) && (nCurChannel != i) )
		{
			if ( m_EncoderSetupInfo[i].m_resolution == RES_1080i ) totalUsedFrames = totalUsedFrames + (m_EncoderSetupInfo[i].m_framerate / 0.4);
			else if ( m_EncoderSetupInfo[i].m_resolution == RES_720p ) totalUsedFrames = totalUsedFrames + (m_EncoderSetupInfo[i].m_framerate / 1);
			else if ( m_EncoderSetupInfo[i].m_resolution == RES_D1 )  totalUsedFrames = totalUsedFrames + (m_EncoderSetupInfo[i].m_framerate / 2.5);
			else if ( m_EncoderSetupInfo[i].m_resolution == RES_CIF ) totalUsedFrames = totalUsedFrames + (m_EncoderSetupInfo[i].m_framerate / 10.5);
			else if ( m_EncoderSetupInfo[i].m_resolution == RES_QCIF ) totalUsedFrames = totalUsedFrames + (m_EncoderSetupInfo[i].m_framerate / 43);
		}
	}
	
	double available720p = MAX_720P_FRAMES - totalUsedFrames;
	
	m_lFrameRateTable[0] = available720p * 0.4;		// 1080i ػ󵵷 ȯ   fps
	m_lFrameRateTable[1] = available720p * 1;		// 720p
	m_lFrameRateTable[2] = available720p * 2.5;		// D1
	m_lFrameRateTable[3] = available720p * 10.5;    // CIF
	m_lFrameRateTable[4] = available720p * 43;		// QCIF
	
	for(i=0; i<5; i++ )
	{
		m_lFrameRateTable[i] = m_lFrameRateTable[i] - 0.5;
	}

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::SetEncoderResolution()
{
	int nChannel = m_EncoderSetupTab.GetCurSel();

	m_cboResolution.ResetContent();

	if( m_EncoderSetupInfo[nChannel].m_ch == CHANNEL1 )
	{
		m_cboResolution.AddString( "1080i" );
		m_cboResolution.AddString( "720p" );
		m_cboResolution.AddString( "D1(4CIF)" );
		m_cboResolution.AddString( "CIF" );
	}
	else if( m_EncoderSetupInfo[nChannel].m_ch == CHANNEL2 )
	{
		m_cboResolution.AddString( "720p" );
		m_cboResolution.AddString( "D1(4CIF)" );
		m_cboResolution.AddString( "CIF" );
		m_cboResolution.AddString( "QCIF" );
	}
	else
	{
		m_cboResolution.AddString( "720p" );
		m_cboResolution.AddString( "D1(4CIF)" );
		m_cboResolution.AddString( "CIF" );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::SetChannelEncoderData()
{
	int nChannel = m_EncoderSetupTab.GetCurSel();
	TRACE( "SetChannelEncoderData(%d)\n", nChannel );

	/*TRACE( "Channel(%d), Codec(%d), Resolution(%d), Framerate(%d), MaxFrameRate(%d), bitrate_mode(%d), bitrate(%d), quality(%d),gop_interval(%d)\n",
		m_EncoderSetupInfo[nChannel].m_ch,
		m_EncoderSetupInfo[nChannel].m_codec_type,
		m_EncoderSetupInfo[nChannel].m_resolution,
		m_EncoderSetupInfo[nChannel].m_framerate,
		m_EncoderSetupInfo[nChannel].m_max_framerate,
		m_EncoderSetupInfo[nChannel].m_bitrate_mode,
		m_EncoderSetupInfo[nChannel].m_bitrate,
		m_EncoderSetupInfo[nChannel].m_quality,
		m_EncoderSetupInfo[nChannel].m_gop_interval	);
	*/
	SetEncoderResolution();

	if( m_EncoderSetupInfo[nChannel].m_codec_type == CODEC_NONE )
	{
		m_cboResolution.EnableWindow( FALSE );
		m_cboFrameRate.EnableWindow( FALSE );
		m_cboBitRateMode.EnableWindow( FALSE );
		m_cboBitRate.EnableWindow( FALSE );
		m_cboQuality.EnableWindow( FALSE );
		m_cboGOPInterval.EnableWindow( FALSE );
		m_edtVideoName.EnableWindow( FALSE );
		m_edtCodecName.EnableWindow( FALSE );

		m_cboCodecType.SetCurSel( ((int)m_EncoderSetupInfo[nChannel].m_codec_type) );
		m_cboResolution.SetCurSel( ((int)m_EncoderSetupInfo[nChannel].m_resolution) );
		m_cboBitRateMode.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_bitrate_mode );
		m_cboBitRate.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_bitrate-1 );
		m_cboQuality.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_quality-1 );
		m_cboGOPInterval.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_gop_interval-1 );
		m_strVideoName.Format( "%s", m_EncoderSetupInfo[nChannel].m_video_name );
		m_strCodecName.Format( "%s", m_EncoderSetupInfo[nChannel].m_codec_name );

		return;
	}
	else
	{
		CalcFrameRate( nChannel );

		m_cboResolution.EnableWindow( TRUE );
		m_cboFrameRate.EnableWindow( TRUE );
		m_cboBitRateMode.EnableWindow( TRUE );
		m_cboBitRate.EnableWindow( TRUE );
		m_cboQuality.EnableWindow( TRUE );
		m_cboGOPInterval.EnableWindow( TRUE );
		m_edtVideoName.EnableWindow( TRUE );
		m_edtCodecName.EnableWindow( TRUE );

		m_cboCodecType.SetCurSel( ((int)m_EncoderSetupInfo[nChannel].m_codec_type) );
		
		char	szTemp[256];
		int		nTempResolution;
		
		for( int i=0; i<m_cboResolution.GetCount(); i++ )
		{
			m_cboResolution.SetCurSel(i);
			m_cboResolution.GetWindowText(szTemp, sizeof(szTemp));
			if( !strcmp(szTemp ,"1080i") )	nTempResolution = 0;
			else if( !strcmp(szTemp ,"720p") )	nTempResolution = 1;
			else if( !strcmp(szTemp ,"D1(4CIF)") )	nTempResolution = 2;
			else if( !strcmp(szTemp ,"CIF") )	nTempResolution = 3;
			else if( !strcmp(szTemp ,"QCIF") )	nTempResolution = 4;
			
			if( nTempResolution == (int)m_EncoderSetupInfo[nChannel].m_resolution )
			{
				m_cboResolution.SetCurSel( i );
				break;
			}
		}

		m_cboBitRateMode.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_bitrate_mode );
		m_cboBitRate.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_bitrate-1 );
		m_cboQuality.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_quality-1 );
		m_cboGOPInterval.SetCurSel( (int)m_EncoderSetupInfo[nChannel].m_gop_interval-1 );
		m_strVideoName.Format( "%s", m_EncoderSetupInfo[nChannel].m_video_name );
		m_strCodecName.Format( "%s", m_EncoderSetupInfo[nChannel].m_codec_name );
	}

	OnSelchangeComboResolution();
	OnSelchangeComboBitRateMode();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CEncoderSetupDlg::SetEncoderDataToServer()
{
	int			nChannel = m_EncoderSetupTab.GetCurSel();
	
	m_EncoderSetupInfo[nChannel].m_ch = (BYTE)nChannel;
	m_EncoderSetupInfo[nChannel].m_codec_type = (DWORD)m_cboCodecType.GetCurSel();
	m_EncoderSetupInfo[nChannel].m_resolution = (DWORD)(m_cboResolution.GetCurSel());
	if( m_cboFrameRate.GetCurSel() == 0 )
		m_EncoderSetupInfo[nChannel].m_framerate = (DWORD)(m_cboFrameRate.GetCurSel()+1);
	else
		m_EncoderSetupInfo[nChannel].m_framerate = (DWORD)(m_cboFrameRate.GetCurSel()*5);
	
	m_EncoderSetupInfo[nChannel].m_bitrate_mode = (DWORD)m_cboBitRateMode.GetCurSel();
	m_EncoderSetupInfo[nChannel].m_bitrate = (DWORD)(m_cboBitRate.GetCurSel()+1);
	m_EncoderSetupInfo[nChannel].m_quality = (DWORD)(m_cboQuality.GetCurSel()+1);
	m_EncoderSetupInfo[nChannel].m_gop_interval = (DWORD)(m_cboGOPInterval.GetCurSel()+1);
	m_EncoderSetupInfo[nChannel].m_priority = 0;
	m_EncoderSetupInfo[nChannel].m_quantizer = 0;
	lstrcpy( m_EncoderSetupInfo[nChannel].m_codec_name, m_strCodecName );
	lstrcpy( m_EncoderSetupInfo[nChannel].m_video_name, m_strVideoName );

	return m_LiveCamera->SetEncoderSetupInfo( nChannel, &m_EncoderSetupInfo[ nChannel ] );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::GetEncoderDataFromServer()
{
	for( int i=CHANNEL1; i<ENCODE_SETUP_CHANNEL_COUNT; i++ )
	{
		memset( &m_EncoderSetupInfo[i], 0, sizeof(ENCODE_SETUP_INFO) );
		m_LiveCamera->GetEncoderSetupInfo( i, &m_EncoderSetupInfo[i], TRUE );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::OnButtonApply() 
{
	// TODO: Add your control notification handler code here
	UpdateData( TRUE );

	CString		strMessage;

	int nRet = SetEncoderDataToServer();

	if( nRet != 0 )
		strMessage.Format( "Invalid Setting Type" );
	else
	{
		strMessage.Format( "Apply Success" );

		// Apply Ŀ Ʈ  ٽ о;.
		GetEncoderDataFromServer();
	}
	AfxMessageBox( strMessage );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::OnSelchangeTabEncoderSetup(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	SetChannelEncoderData();
	UpdateData( FALSE );

	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::OnSelchangeComboResolution() 
{
	// TODO: Add your control notification handler code here
	int		nUseMaxFps = 0;
	int		nChannel = m_EncoderSetupTab.GetCurSel();
	int		nSelectIndex = 0;
	CString	strTemp;

	m_cboFrameRate.ResetContent();

	switch( m_EncoderSetupInfo[nChannel].m_resolution )
	{
	case RES_1080i:	nUseMaxFps = (int)m_lFrameRateTable[RES_1080i];	break;
	case RES_720p:	nUseMaxFps = (int)m_lFrameRateTable[RES_720p];	break;
	case RES_D1:	nUseMaxFps = (int)m_lFrameRateTable[RES_D1];		break;
	case RES_CIF:	nUseMaxFps = (int)m_lFrameRateTable[RES_CIF];	break;
	case RES_QCIF:	nUseMaxFps = (int)m_lFrameRateTable[RES_QCIF];	break;
		break;
	}

	int nUseMaxIndex = (nUseMaxFps/5) -1;
	//TRACE( "nUserMaxFps(%d) nUseMaxIndex(%d)\n", nUseMaxFps, nUseMaxIndex );

	// Channel 1 1080i 쿡 15fps ִ̰,  ä 1ä fps̻   .
	if( m_cboResolution.GetCurSel() == RES_1080i )
	{
		if( m_EncoderSetupInfo[nChannel].m_ch == CHANNEL1 )
			nUseMaxIndex = 3;
		else
			nUseMaxIndex = m_EncoderSetupInfo[CHANNEL1].m_framerate/5;
	}

	for( int i=0; i<=nUseMaxIndex; i++ )
	{
		if( i == 0 )
			strTemp.Format( "1 fps");
		else
		{
			// 1080i  ػ󵵿 30fps   ( NTSC ), 25 ( PALϰ )
			if( (m_cboResolution.GetCurSel() != RES_1080i) && ( (i*5) > (int)m_EncoderSetupInfo[nChannel].m_max_framerate) )
				break;

			strTemp.Format( "%d fps", i*5 );
		}

		if( (int)(m_EncoderSetupInfo[nChannel].m_framerate) == (i*5) )
			nSelectIndex = i;

		//TRACE( "Frame Type [ %s ] fps\n", strTemp );
		m_cboFrameRate.AddString( strTemp );
	}

	m_cboFrameRate.SetCurSel(nSelectIndex);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::OnSelchangeComboBitRateMode() 
{
	// TODO: Add your control notification handler code here
	if( m_cboBitRateMode.GetCurSel() == BITRATE_CBR )
	{
		m_cboQuality.EnableWindow( FALSE );
		m_cboBitRate.EnableWindow( TRUE );
	}
	else
	{
		m_cboQuality.EnableWindow( TRUE );
		m_cboBitRate.EnableWindow( FALSE );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CEncoderSetupDlg::OnSelchangeComboCodecType() 
{
	// TODO: Add your control notification handler code here
	SetEncoderResolution();
}
