/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ProbeDemoDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROBEDEMODLG_H__F496D7F9_7A7B_41DE_A3A8_7E7B7CE176F3__INCLUDED_)
#define AFX_PROBEDEMODLG_H__F496D7F9_7A7B_41DE_A3A8_7E7B7CE176F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Definition
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define TIMER_CHECK_RCV			1
#define TIME_CHECK_RCV			10

#define TIMER_DRAW_RENDER			100
#define TIME_DRAW_RENDER			10

#define CONNECT_PROBE_IP		"192.168.1.81"
#define CONNECT_PENTA_IP		"192.168.1.96"

#define CONNECT_CONTROL_PORT	"7777"
#define CONNECT_VIDEO_PORT		"7778"
#define CONNECT_AUDIO_TX_PORT	"7779"
#define CONNECT_AUDIO_RX_PORT	"7780"

#define CONNECT_ID				"admin"
#define CONNECT_PASSWORD		"admin"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <d3d8.h>
#include <d3dx8.h>

#include "LiveDemo.h"
#include "PTZButton.h"
#include "VideoSetupDlg.h"
#include "EncoderSetupDlg.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CProbeDemoDlg dialog
class CProbeDemoDlg : public CDialog
{
private:
	CLiveObject			*m_LiveCamera;
	HDRAWDIB			m_hDrawDib;
	
	VIDEO_DATA_PACK		m_RcvVideData;
	BOOL				m_IsDecodingSuccess;
	
	CVideoSetupDlg		*m_VideoSetupDlg;
	CEncoderSetupDlg	*m_EncoderSetupDlg;

	int					m_nCurChannel;
	int					m_nCurOutputNum;
	
	WORD				m_wPan;
	WORD				m_wTilt;
	WORD				m_wZoom;

	BYTE				m_byAlarmIn;
	BYTE				m_byAlarmOut;

	//..................................................

public:
	CProbeDemoDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CProbeDemoDlg();

	//..................................................

public:
	void DisplayVideoInfo();
		
	//..................................................

	// Dialog Data
	//{{AFX_DATA(CProbeDemoDlg)
	enum { IDD = IDD_PROBEDEMO_DIALOG };
	CSliderCtrl	m_sliderSensitivity;
	CPTZButton	m_btnPTZZoomOut;
	CPTZButton	m_btnPTZZoomIn;
	CPTZButton	m_btnPTZdown;
	CPTZButton	m_btnPTZup;
	CPTZButton	m_btnPTZrightup;
	CPTZButton	m_btnPTZrightdown;
	CPTZButton	m_btnPTZright;
	CPTZButton	m_btnPTZleftup;
	CPTZButton	m_btnPTZleftdown;
	CPTZButton	m_btnPTZleft;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProbeDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CProbeDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonConnect();
	afx_msg void OnButtonDisconnect();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	afx_msg void OnSelchangeComboChannel();
	afx_msg void OnSelchangeComboMotionMode();
	afx_msg void OnButtonVideoSetup();
	afx_msg void OnButtonAudioinRecord();
	afx_msg void OnButtonEncoderSetting();
	afx_msg void OnButtonSpeedApply();
	afx_msg void OnButtonPtzApply();
	afx_msg void OnButtonPtzGet();
	afx_msg void OnButtonOutputOn();
	afx_msg void OnButtonOutputOff();
	afx_msg void OnButtonVideoConnect();
	afx_msg void OnButtonSpeakerConnect();
	afx_msg void OnButtonMicConnect();
	afx_msg void OnButtonSpeakerOnoff();
	afx_msg void OnButtonMicOnoff();
	afx_msg void OnButtonExit();
	afx_msg void OnSelchangeComboRelayOutIndex();
	afx_msg void OnButtonAlarmInoutStatus();
	afx_msg void OnCheckMotion();
	afx_msg void OnButtonAllMot();
	afx_msg void OnButtonClearMot();
	afx_msg void OnButtonSaveMot();
	afx_msg void OnButtonloadMot();
	afx_msg void OnButtonSaveSen();
	afx_msg void OnButtonLoadSen();
	afx_msg void OnButtonZoomin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROBEDEMODLG_H__F496D7F9_7A7B_41DE_A3A8_7E7B7CE176F3__INCLUDED_)
