// Texture.h: interface for the CTexture class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TEXTURE_H__EDE1C4D8_3722_4521_A708_A4922B304928__INCLUDED_)
#define AFX_TEXTURE_H__EDE1C4D8_3722_4521_A708_A4922B304928__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <d3d8types.h>
#include <d3d8.h>
#include <d3dx8.h>

struct CUSTOMVERTEX
{
    D3DXVECTOR3 position; // The position
	float		rhw;
    D3DCOLOR    color;    // The color
    FLOAT       tu0, tv0;   // The texture coordinates
};
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)

class CTexture  
{
private:
	_D3DFORMAT m_d3dformat;
	int m_TextureWidth;
	int m_TextureHeight;

	int m_WindowWidth;
	int m_WindowHeight;

	int	m_nWidth;
	int m_nHeight;

	LPDIRECT3DVERTEXBUFFER8 m_VertexBuffer;
	LPDIRECT3DTEXTURE8		m_pTexture;
	LPDIRECT3DDEVICE8       m_pDevice;
public:
	void Draw(long x, long y, long w, long h, 
							float tx, float ty, float tw, float th,
							D3DCOLOR color);
	int Blt(BYTE *pVideoBuffer, int nWidth, int nHeight, int nPitch);
	LPDIRECT3DTEXTURE8			GetTexture();
	LPDIRECT3DVERTEXBUFFER8		GetVertexBuffer();
	void SetVertRect(int x, int y, int w, int h, float d);

	int GetWindowWidth();
	int GetWindowHeight();
	int GetWidth();
	int GetHeight();
	_D3DFORMAT GetFormat();
	HRESULT Init(LPDIRECT3DDEVICE8 pDevice, int nWindowWidth, int nWindowHeight, _D3DFORMAT d3dformat);
	void	Clear();
	CTexture();
	~CTexture(void);
};

#endif // !defined(AFX_TEXTURE_H__EDE1C4D8_3722_4521_A708_A4922B304928__INCLUDED_)
