// VideoRender.h: interface for the CVideoRender class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIDEORENDER_H__0E9FCD6D_5F30_4F7E_B9D4_0F8633BD00C2__INCLUDED_)
#define AFX_VIDEORENDER_H__0E9FCD6D_5F30_4F7E_B9D4_0F8633BD00C2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <d3d8.h>
#include <d3dx8.h>
#include "Texture.h"
#include "DirectXFont.h"

class CVideoRender  
{
protected:
	BOOL   m_bStop;
	HANDLE m_hThread;
	HANDLE m_hEventThread;
	LPDIRECT3D8        m_Dx3D;
	LPDIRECT3DDEVICE8  m_d3dDevice;
	CTexture		   *m_Texture;
	CDirectXFont       m_Font;
	LPDIRECT3DVERTEXBUFFER8 m_pStaticTextBuffer;

	void Clear();
	void Render();
public:
	void ExecuteThread();
	CVideoRender();
	virtual ~CVideoRender();

	BOOL Start();
	void Stop();
	HRESULT Init(HWND hWnd,  int x, int y, DWORD dwWWidth, DWORD dwWHeight);
	
	void DrawImage(BYTE *lpData, DWORD dwWidth, DWORD dwHeight);
	void PreRender();
	HRESULT PostRender();
};

UINT WINAPI _RenderThread(LPVOID lpParam);

#endif // !defined(AFX_VIDEORENDER_H__0E9FCD6D_5F30_4F7E_B9D4_0F8633BD00C2__INCLUDED_)
