// SoundCaptureManager.h: interface for the CSoundCaptureManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDCAPTUREMANAGER_H__8825FE17_1EA9_48DD_BD3E_701D3E8C1716__INCLUDED_)
#define AFX_SOUNDCAPTUREMANAGER_H__8825FE17_1EA9_48DD_BD3E_701D3E8C1716__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include <MMREG.H>
#include <dxerr8.h>
#include <dsound.h>

#define NUM_REC_NOTIFICATIONS  16
#define MAX(a,b)        ( (a) > (b) ? (a) : (b) )

#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }

typedef HRESULT (*LPFNC_CAPTUREDATA)(LPBYTE lpCapBuf, DWORD dwSize, LPVOID lpData);

class CSoundCaptureManager  
{
public:
	HRESULT CreateCaptureBuffer( WAVEFORMATEX* pwfxInput );
	HRESULT CapturedData();
	void SetBufferFormat(DWORD dwPrimaryChannels, DWORD dwPrimaryFreq, DWORD dwPrimaryBitRate);
	HRESULT InitDirectSound();
	void StopCapture();
	BOOL StartCapture();
	void ExecuteThread();
	HRESULT InitNotifications();
	void Finalize();
	BOOL Initialize(LPFNC_CAPTUREDATA Function_Callback, LPVOID lpCallbackData,DWORD dwPrimaryChannels, DWORD dwPrimaryFreq, DWORD dwPrimaryBitRate);
		
	CSoundCaptureManager();
	virtual ~CSoundCaptureManager();
	
private:
	
	LPDIRECTSOUNDCAPTURE       m_pDSCapture         ;
	LPDIRECTSOUNDCAPTUREBUFFER m_pDSBCapture        ;
	LPDIRECTSOUNDNOTIFY        m_pDSNotify          ;
	GUID                       m_guidCaptureDevice  ;
	WAVEFORMATEX               m_wfxInput;
	DSBPOSITIONNOTIFY          m_aPosNotify[ NUM_REC_NOTIFICATIONS + 1 ];  
	HANDLE                     m_hNotificationEvent[2]; 
	BOOL                       m_abInputFormatSupported[16];
	DWORD                      m_dwCaptureBufferSize;
	DWORD                      m_dwNextCaptureOffset;
	DWORD                      m_dwNotifySize;

	LPFNC_CAPTUREDATA CB_CALLBACK;
	LPVOID m_lpCallbackData;
	HANDLE m_hThread;
	BOOL   m_bActive;
};

UINT WINAPI SoundCaptureThread(LPVOID lpParam);

#endif // !defined(AFX_SOUNDCAPTUREMANAGER_H__8825FE17_1EA9_48DD_BD3E_701D3E8C1716__INCLUDED_)
