// TwowayControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TwowayControl.h"
#include "TwowayControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwowayControlDlg dialog

CTwowayControlDlg::CTwowayControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTwowayControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTwowayControlDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hConnection   = NULL;
	m_hAudEnc		= NULL;
	m_pWaveIn		= NULL;
	m_lpData        = new AUDIO_DATA_PACK();
	memset(m_lpData, 0, sizeof(AUDIO_DATA_PACK));
	m_pSendDataBuf = new BYTE[4*4096];
	m_dwFrameNum    = 0;
}

void CTwowayControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTwowayControlDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTwowayControlDlg, CDialog)
	//{{AFX_MSG_MAP(CTwowayControlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_DISCON, OnButtonDiscon)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwowayControlDlg message handlers

BOOL CTwowayControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	InitControls();
	InitValues();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTwowayControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTwowayControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTwowayControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTwowayControlDlg::InitControls()
{
	// Initialize SDK
	_PROBENET_INIT();

	m_hAudEnc = AUDG711ENCODER_INIT();
	m_pWaveIn = new CWaveInUtil(1, 16000, 16); 
	m_pWaveIn->InitSoundCapture(CTwowayControlDlg::GetCaptureData, (LPVOID)this);

	char szAddr[255];
	char szControlPort[255];
	char szAudioOutPort[255];
	char szUserId[255];
	char szPasswd[255];
	
	GetDlgItem(IDC_EDIT_ADDR)->GetWindowText(szAddr, sizeof(szAddr));
	GetDlgItem(IDC_EDIT_PORT)->GetWindowText(szControlPort, sizeof(szControlPort));
	GetDlgItem(IDC_EDIT_PORT_AUDIOOUT)->GetWindowText(szAudioOutPort, sizeof(szAudioOutPort));
	GetDlgItem(IDC_EDIT_ID)->GetWindowText(szUserId, sizeof(szUserId));
	GetDlgItem(IDC_EDIT_PASSWD)->GetWindowText(szPasswd, sizeof(szPasswd));	
	
	CONNECTION_INFO ConnectionInfo;
	DWORD dwMaskCreatingSocks = _CONTROL_SOCK|_AUDIOSEND_SOCK;
	memset(&ConnectionInfo, 0, sizeof(ConnectionInfo));
	lstrcpy(ConnectionInfo.m_szAddress, szAddr);
	lstrcpy(ConnectionInfo.m_szUserId, szUserId);
	lstrcpy(ConnectionInfo.m_szPassWd, szPasswd);
	ConnectionInfo.m_wControlPort	= (WORD)atoi(szControlPort);
	ConnectionInfo.m_wVideoPort		= 0;
	ConnectionInfo.m_wAudioPort		= 0;
	ConnectionInfo.m_wMikePort		= (WORD)atoi(szAudioOutPort);
	
	m_hConnection = _PROBENET_CONNECTION_INIT(&ConnectionInfo, dwMaskCreatingSocks);
	if(m_hConnection)
	{
		_PROBENET_AUDIOSENDER_SETCALLFUNC(m_hConnection, NULL, CTwowayControlDlg::_ON_ERROR, (HANDLE)this);
	}
}
void CTwowayControlDlg::InitValues()
{
	GetDlgItem(IDC_EDIT_ADDR)->SetWindowText(DEFAULT_ADDR);
	GetDlgItem(IDC_EDIT_PORT)->SetWindowText(DEFAULT_CONTROL_PORT);
	GetDlgItem(IDC_EDIT_PORT_AUDIOOUT)->SetWindowText(DEFAULT_AUDIOOUT_PORT);
	GetDlgItem(IDC_EDIT_ID)->SetWindowText(DEFAULT_ID);
	GetDlgItem(IDC_EDIT_PASSWD)->SetWindowText(DEFAULT_PASSWD);
}
void CTwowayControlDlg::EndControls()
{
	// Delete Connection Instance.
	if(m_hConnection)
	{
		_PROBENET_CONNECTION_END(m_hConnection);
		m_hConnection = NULL;
	}
	// Finalize SDK
	_PROBENET_END();

	if(m_pWaveIn)
	{
		m_pWaveIn->Stop();
		delete m_pWaveIn;
		m_pWaveIn = NULL;
	}
	if(m_hAudEnc)
	{
		AUDG711ENCODER_END(m_hAudEnc);
		m_hAudEnc = NULL;
	}
	if(m_lpData)
	{
		delete m_lpData;
		m_lpData = NULL;
	}
	if(m_pSendDataBuf)
	{
		delete [] m_pSendDataBuf;
		m_pSendDataBuf = NULL;
	}
}

void CTwowayControlDlg::OnButtonConnect() 
{
	// TODO: Add your control notification handler code here
	if(m_hConnection)
	{
		_PROBENET_CONNECTION_DISCONNECT(m_hConnection, _CONTROL_SOCK|_AUDIOSEND_SOCK);
	}	
	char szAddr[255];
	char szControlPort[255];
	char szAudioOutPort[255];
	char szUserId[255];
	char szPasswd[255];
	
	GetDlgItem(IDC_EDIT_ADDR)->GetWindowText(szAddr, sizeof(szAddr));
	GetDlgItem(IDC_EDIT_PORT)->GetWindowText(szControlPort, sizeof(szControlPort));
	GetDlgItem(IDC_EDIT_PORT_AUDIOOUT)->GetWindowText(szAudioOutPort, sizeof(szAudioOutPort));
	GetDlgItem(IDC_EDIT_ID)->GetWindowText(szUserId, sizeof(szUserId));
	GetDlgItem(IDC_EDIT_PASSWD)->GetWindowText(szPasswd, sizeof(szPasswd));	
	
	CONNECTION_INFO ConnectionInfo;
	DWORD dwMaskCreatingSocks = _CONTROL_SOCK|_AUDIOSEND_SOCK;
	memset(&ConnectionInfo, 0, sizeof(ConnectionInfo));
	lstrcpy(ConnectionInfo.m_szAddress, szAddr);
	lstrcpy(ConnectionInfo.m_szUserId, szUserId);
	lstrcpy(ConnectionInfo.m_szPassWd, szPasswd);
	ConnectionInfo.m_wControlPort	= (WORD)atoi(szControlPort);
	ConnectionInfo.m_wVideoPort		= 0;
	ConnectionInfo.m_wAudioPort		= 0;
	ConnectionInfo.m_wMikePort		= (WORD)atoi(szAudioOutPort);

	_PROBENET_CONNECTION_SETVALUE(m_hConnection, &ConnectionInfo);
	
	_PROBENET_CONNECTION_CONNECT(m_hConnection, _CONTROL_SOCK|_AUDIOSEND_SOCK);	
	//m_pWaveIn->Start();
}

void CTwowayControlDlg::OnButtonDiscon() 
{
	// TODO: Add your control notification handler code here
	//m_pWaveIn->Stop();
	if(m_hConnection)
	{
		_PROBENET_CONNECTION_DISCONNECT(m_hConnection, _CONTROL_SOCK|_AUDIOSEND_SOCK);
	}		
}

void CTwowayControlDlg::OnButtonClose() 
{
	// TODO: Add your control notification handler code here
	m_pWaveIn->Stop();
	if(m_hConnection)
	{
		_PROBENET_CONNECTION_DISCONNECT(m_hConnection, _CONTROL_SOCK|_AUDIOSEND_SOCK);
	}	
	
	EndDialog(IDOK);	
}

void CTwowayControlDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	EndControls();
}
HRESULT CTwowayControlDlg::GetCaptureData(LPBYTE lpCapBuf, DWORD dwSize, LPVOID lpData)
{
	CTwowayControlDlg *pDlg = (CTwowayControlDlg *)lpData;
	if(pDlg)
	{
		pDlg->OnCaptureData(lpCapBuf, dwSize);
	}
	return 0;
}
void CTwowayControlDlg::OnCaptureData(LPBYTE lpCapBuf, DWORD dwSize)
{
	if(m_hConnection && m_hAudEnc)
	{
		CTime time = CTime::GetCurrentTime();
		TRACE("OnCaptureData %d : %s", dwSize, (char *)(LPCTSTR)time.Format("%x %X"));
		DWORD dwSliceNum = 0;
		DWORD dwOutLen;
		if(AUDG711ENCODER_ENCODE(m_hAudEnc, (char *)lpCapBuf, dwSize, (char *)m_pSendDataBuf, dwOutLen))
		{
			m_dwFrameNum++;
			if(m_dwFrameNum > 600000)
			{
				m_dwFrameNum = 1;
			}
			int nPos=0;
			DWORD dwLeftSize = dwOutLen;
			while(dwLeftSize > 0)
			{
				DWORD dwSendSize=0;
				if(dwLeftSize > MAX_VIDEO_BUFFER_SIZE)
				{
					dwSendSize = MAX_VIDEO_BUFFER_SIZE;
				}
				else
				{
					dwSendSize = dwLeftSize;
				}
				m_lpData->m_nFrame_Size = dwOutLen;
				m_lpData->m_nSlice_Size = dwSendSize;
				m_lpData->m_nFrame_Num  = m_dwFrameNum;
				m_lpData->m_isCompMode  = 1;
				m_lpData->m_nSlice_Num  = dwSliceNum++;
				CopyMemory(m_lpData->m_szFrameData, m_pSendDataBuf+nPos, dwSendSize);
				_PROBENET_AUDIOSENDER_SENDPACK(m_hConnection, m_lpData);
				dwLeftSize  -= dwSendSize;
				nPos		+= dwSendSize;
			}
		}
	}
}
void CTwowayControlDlg::_ON_ERROR(HANDLE hCallback, int nErrorCode)
{
	CTwowayControlDlg *pDlg = (CTwowayControlDlg *)hCallback;
	if(pDlg)
	{
		pDlg->ON_ERROR(nErrorCode);
	}
}
void CTwowayControlDlg::ON_ERROR(int nErrorCode)
{
	switch(nErrorCode)
	{
	case _PROBE_SOCK_CONNECT_SUCCESS:	//	Ἲ

		m_pWaveIn->Start();
		break;
	case _PROBE_SOCK_CONNECT_FAILED:	//	

		break;
	case _PROBE_SOCK_CONNECT_NOTAVAIL:	//	ȿ ּҰ ƴ

		break;
	case _PROBE_SOCK_CONNECT_FAULT:		//	߸ּ

		break;
	case _PROBE_SOCK_CONNECT_TIMEOUT:	//	ðʰ

		break;
	case _PROBE_SOCK_DISCONNECTED:		//  
		m_pWaveIn->Stop();
		break;
	default:
		break;
	}
}
