// WaveOutUtil.cpp: implementation of the CWaveOutUtil class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WaveOutUtil.h"

#include "DXUTIL.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//0714 dsyoo
//----------------------------------------------------------
CWaveOutUtil::CWaveOutUtil(int nChannel, int nSamplesPerSec, int nBitsPerSample)
{
//---------------------------------------------------------------------------
	m_pSoundManager=NULL;	//Live play
	m_pSound=NULL;			//Live play

	m_nChannel	= nChannel;
	m_nSamplesPerSec = nSamplesPerSec;
	m_nBitsPerSample = nBitsPerSample;

    ZeroMemory( &m_wfxInput, sizeof(m_wfxInput));
    m_wfxInput.wFormatTag = WAVE_FORMAT_PCM;
    m_wfxInput.nChannels       = (WORD) m_nChannel; 
    m_wfxInput.nSamplesPerSec  = m_nSamplesPerSec; 
    m_wfxInput.wBitsPerSample  = (WORD) m_nBitsPerSample; 
    m_wfxInput.nBlockAlign     = m_wfxInput.wBitsPerSample / 8 * m_wfxInput.nChannels;
    m_wfxInput.nAvgBytesPerSec = m_wfxInput.nSamplesPerSec * m_wfxInput.nBlockAlign;
	/*
	m_wfxInput.nAvgBytesPerSec=8000*2;
	m_wfxInput.nBlockAlign=1*2;
	m_wfxInput.nChannels=m_nChannel;
	m_wfxInput.nSamplesPerSec=m_nSamplesPerSec;
	m_wfxInput.wBitsPerSample=(WORD)m_nBitsPerSample;
	m_wfxInput.wFormatTag=WAVE_FORMAT_PCM;
	*/

	//---------- g.723 ------------------//
	/*
	m_wfxInput.wf.nAvgBytesPerSec=800;
	m_wfxInput.wf.nBlockAlign=24;
	m_wfxInput.wf.nChannels=1;
	m_wfxInput.wf.nSamplesPerSec=8000;
	m_wfxInput.wf.wBitsPerSample=0;
	m_wfxInput.wf.wFormatTag=WAVE_FORMAT_MSG723;
	m_wfxInput.wf.cbSize = 10;

	m_wfxInput.extra[0] = 2;
	m_wfxInput.extra[1] = 0;
	m_wfxInput.extra[2] = 0xCE;
	m_wfxInput.extra[3] = 0x9A;
	m_wfxInput.extra[4] = 0x32;
	m_wfxInput.extra[5] = 0xF7;
	m_wfxInput.extra[6] = 0xA2;
	m_wfxInput.extra[7] = 0xAE;
	m_wfxInput.extra[8] = 0xDE;
	m_wfxInput.extra[9] = 0xAC;
	*/
    //------------------------------------//

	
	m_iAudBufCnt=0;
	m_pPlayAudBuf=new BYTE[1024*1024];
	m_pCapAudBuf=new BYTE[1024*1024];
	m_pHwnd=NULL;

	m_bPlaying=FALSE;

}

CWaveOutUtil::~CWaveOutUtil()
{
	if(m_pSound)
	{
		delete m_pSound;
		m_pSound = NULL;
	}
	if(m_pPlayAudBuf)
	{
		delete m_pPlayAudBuf;
		m_pPlayAudBuf=NULL;
	}
	if(m_pCapAudBuf)
	{
		delete m_pCapAudBuf;
		m_pCapAudBuf=NULL;
	}
	if(m_pSoundManager)
	{
		delete m_pSoundManager;
		m_pSoundManager=NULL;
	}
}

void CWaveOutUtil::InitSoundPlay(HWND wnd)
{
	m_pHwnd=wnd;
	InitSoundPlay();
}

void CWaveOutUtil::EndVoice()
{
	if(m_pSound)
	{
		if(m_pSound->IsSoundPlaying())
			m_pSound->Stop();
	}
	SAFE_DELETE(m_pSound);
	if(m_pPlayAudBuf)
	{
		memset(m_pPlayAudBuf,0x80,1024*1024);
		m_iAudWritePos=0;
		m_iAudBufCnt=0;
	}
	if(m_pCapAudBuf)
	{
		memset(m_pCapAudBuf,0x80,1024*1024);
	}
	if(m_pSoundManager)
	{
		SAFE_DELETE(m_pSoundManager);
	}
}
void CWaveOutUtil::PlayVoice(BYTE *pData,int nSize)
{
	if(m_iAudWritePos+nSize >=1024*1024)
	{
		TRACE("===========Buffer Exceeded!===========\n");
	}
/*
	if(m_bPlaying)
	{
		TRACE("===========In play process!===========\n");
		return;
	}
	m_bPlaying=TRUE;
*/
	if(!m_pSoundManager) // Ŵ  
	{
		InitSoundPlay();
	}
	if(!m_pSoundManager)
		return;
	if(!m_pSound)    // ÷ ʱȭ
	{
		SAFE_DELETE(m_pSound);
		DWORD dwCreationFlags=0;
		// Add extra flags needed for the UI
		dwCreationFlags |= DSBCAPS_CTRLPAN | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY|DSBCAPS_GLOBALFOCUS ;
		TRACE("Init sound play\n");
		if(m_pSoundManager->CreateFromMemory(&m_pSound,
			m_pPlayAudBuf,
			1024*1024,//m_stVoice[iSelChannel].iSize,
			(WAVEFORMATEX *)&m_wfxInput,
			dwCreationFlags,
			GUID_NULL
			))
		{
			//
			TRACE("Play Sound Init Fail");
		}
		m_iAudWritePos=0;
	}
	if(m_pSound)  //Sound Play   
	{
		if(!m_pSound->IsSoundPlaying())
		{
			if(m_iAudBufCnt>0)
			{
				if(m_iAudWritePos)
				{
					m_pSound->Play(0,0);
				}
			}
			++m_iAudBufCnt;
		}
			
	}
	LPDIRECTSOUNDBUFFER pDSB;
	if(m_pSound)
	{
		pDSB = m_pSound->GetBuffer( 0 );

		if(m_pSound->IsSoundPlaying())
		{
			DWORD p,w;
			pDSB->GetCurrentPosition(&p,&w);
			if((int)p>m_iAudWritePos)
			{
				m_pSound->Stop();
				m_iAudWritePos=0;
				m_iAudBufCnt=0;
			}
		}
	}

	if(m_iAudWritePos+nSize < 1024*1024)
	{
		if(m_pSound)
		{
			DWORD p,w;
			pDSB->GetCurrentPosition(&p,&w);
			
			if((int)p>m_iAudWritePos && m_iAudBufCnt>0)
			{
				m_pSound->Stop();
				m_pSound->Reset();
				memset(m_pPlayAudBuf,0x80,1024*1024);
				m_iAudWritePos=0;
				m_iAudBufCnt=0;
			}
			memcpy(m_pPlayAudBuf+m_iAudWritePos,pData,nSize);
			m_iAudWritePos+=(nSize);
		}
	}
	else 
	{
		if(m_pSound)//Sound Play   
		{
			m_pSound->Stop();
			memset(m_pPlayAudBuf,0x80,1024*1024);
			m_iAudWritePos=0;
			m_iAudBufCnt=0;
		}
		memcpy(m_pPlayAudBuf+m_iAudWritePos,pData,nSize);
		m_iAudWritePos=nSize;

	}
	if(m_pSound)//Sound Play   
	{
		m_pSound->FillBufferWithSound( pDSB,1,m_pPlayAudBuf);
	}
//	m_bPlaying=FALSE;
}
void CWaveOutUtil::InitSoundPlay()
{
	HRESULT hr;
	if(m_pHwnd)
	{
		if(!m_pSoundManager)
		{
			m_pSoundManager=new CSoundManager();   
			//if(FAILED( hr = m_pSoundManager->Initialize(m_pHwnd,DSSCL_PRIORITY,1,8000,8)))
			if(FAILED( hr = m_pSoundManager->Initialize(m_pHwnd,DSSCL_PRIORITY,m_nChannel,m_nSamplesPerSec,m_nBitsPerSample))) // mono, 16bit
			{
				TRACE("Sound Play Init. Fail\n");
				delete m_pSoundManager;
				m_pSoundManager=NULL;
			}
		}
	}
}

void CWaveOutUtil::StopVoice()
{
	if(m_pPlayAudBuf)
	{
		if(m_pSound)
		{
			m_pSound->Stop();
		}
		memset(m_pPlayAudBuf,0x80,1024*1024);
		m_iAudWritePos=0;
		m_iAudBufCnt=0;
	}
	if(m_pCapAudBuf)
	{
		memset(m_pCapAudBuf,0x80,1024*1024);
	}
}

BOOL CWaveOutUtil::IsSoundPlaying()
{
	if(m_pSound)
	{
		if(m_pSound->IsSoundPlaying())
			return TRUE;
	}
	return FALSE;
}

int CWaveOutUtil::MonitorPos()
{
	if(m_pSound)
	{
		if(m_pSound->IsSoundPlaying())
		{
			LPDIRECTSOUNDBUFFER pDSB;
			pDSB = m_pSound->GetBuffer( 0 );
			DWORD p,w;
			pDSB->GetCurrentPosition(&p,&w);  // ÷  ġ ã´.
			if(m_iAudWritePos>(int)p && m_iAudBufCnt>1)
			{
				return -1;		//÷    ġ  ִ.
			}
			else
			{
				return 1;		//÷    ġ Ѱ.

			}
			return TRUE;
		}
	}
	return 0;  
}
